// load modules
var https = require('https');       //LINE APIを利用するためのHTTPSクライアント
var aws = require('aws-sdk');       //S3、Pollyを利用するためのAWS SDK
var s3 = new aws.S3({region: 'us-east-1'});
var BUCKET_NAME = 'iot-filesv';
var DIRECTORY_PATH = 'line/lineid'
var msg = "メッセージを聞きました"

exports.handler = (event, context, callback) => {
    // TODO implement
    console.log('EVENT:', JSON.stringify(event, null, 2));
    
    //S3からLINE ID取得
    s3LineIdGetParams = {
        Bucket: BUCKET_NAME,
        Key: DIRECTORY_PATH,
    }
    s3.getObject(s3LineIdGetParams, function(err, data) {
        if (err) {
            console.log("S3 Get Error:" + err);
        } else {
            var lineid = data.Body.toString();
            //lineid = data.Body;
            console.log("S3 Get Success:" + lineid)
            
            // Request Body
            var request_body = JSON.stringify({
                to: lineid,
                messages:[
                    {
                        "type":"text",
                        "text": msg
                    }
                ]
            });

            // Request Headers
            var send_options = {
                host: 'api.line.me',
                path: '/v2/bot/message/push',
                headers: {
                    "Content-type": "application/json; charset=UTF-8",
                    "Authorization": " Bearer " + "LINEの「 Channel Access Token」を指定"
                },
                method: 'POST'
            };

            // APIリクエスト
            var req = https.request(send_options, function(res){
                res.on('request_body', function (chunk) {
                    console.log(res.statusCode + chunk.toString());
                });
                req.on('error', function(err) {
                    console.log('ERROR: ' + err.message);
                });
            });
            req.write(request_body);
            req.end();
        }
    });

};