import paho.mqtt.client as mqtt
import json
import pygame.mixer
import time
import urllib

MP3_FILENAME = 'twilio_message.mp3'

MQTT_HOST = '127.0.0.1'
MQTT_PORT = 1883
MQTT_TOPIC = '/raspi3/loudspeaker/twilio'
MQTT_KEEPALIVE = 60
MQTT_QOS = 0


def on_connect(mqtt_cl, obj, res_code):
	print("mqtt connect: res_code: "+str(res_code))

def on_subscribe(mqttc, obj, mid, granted_qos):
	print("Subscrib: "+str(mid)+" "+str(granted_qos))

def on_message(mqtt_cl, obj, msg):
	print("message recv: "+msg.topic+" "+str(msg.qos)+" "+str(msg.payload))
	try:
		mqtt_data = json.loads(msg.payload)
	except ValueError as e:
		print e
	print(json.dumps(mqtt_data))
	
	urllib.urlretrieve(mqtt_data.get('url'),"{0}".format(MP3_FILENAME))

	pygame.mixer.init()
	twilio_message = pygame.mixer.Sound(MP3_FILENAME)
	twilio_message.play()

mqtt_cl = mqtt.Client()
mqtt_cl.on_connect = on_connect
mqtt_cl.on_subscribe = on_subscribe
mqtt_cl.on_message = on_message
mqtt_cl.connect(MQTT_HOST, MQTT_PORT, MQTT_KEEPALIVE)
mqtt_cl.subscribe(MQTT_TOPIC, MQTT_QOS)
mqtt_cl.loop_forever()
